import java.util.ArrayList;
import java.util.List;

public class Main {
    //psvm tab
    public static void main(String[] args) {

        // ARRAYS
        // static size
        // used when we know how many elements we use
        String[] namesArray = new String[5];
        namesArray[0] = "Alicja";
        namesArray[1] = "Jan";
        namesArray[2] = "Bonifacy";
        namesArray[3] = "Eugeniusz";
        namesArray[4] = "Matylda";
        for (int i = 0; i < namesArray.length; i++) {
            System.out.println(namesArray[i]);
        }
        System.out.println("Array size: " + namesArray.length);

        int[] numbersArray = new int[10];
        for(int i = 0; i < numbersArray.length; i++){
            numbersArray[i] = i;
        }

        for(int number : numbersArray){ // for each
            System.out.println(number);
        }

        for(String name : namesArray){
            System.out.println(name);
        }



        // LISTS
        // indexed
        // automatically increased/decreased while we add/remove elements
        // can store duplicates
        // ArrayList
        // LinkedList
        List<String> nameList = new ArrayList<>();
        nameList.add("Alicja"); // add to list
        nameList.add("Jan");
        nameList.add("Bonifacy");
        nameList.add("Eugeniusz");
        nameList.add("Matylda");
        nameList.add("Jan");

        System.out.println("List of names");
        System.out.println(nameList.get(0)); // get method - returns the element using its index (from 0)
        System.out.println(nameList.get(2));
        System.out.println(nameList.get(5));

        System.out.println("Displaying elements using for");
        for(int i = 0; i < nameList.size(); i++){ // size - returns number of elements
            System.out.println(nameList.get(i));
        }

        nameList.add(1,"Marcin"); // add element - placing him using index

        System.out.println("Displaying elements using for ech");
        for(String name : nameList){
            System.out.println(name);
        }

        System.out.println(nameList.contains("Matylda")); // contains returns true or false informing whether
        System.out.println(nameList.contains("Marian")); // the element is on the list

        nameList.remove("Marcin"); // removing element using value
        System.out.println("Displaying elements using for ech after removing Marcin from the list");
        for(String name : nameList){
            System.out.println(name);
        }

        nameList.remove(2); // removing element using index
        System.out.println("Displaying elements using for ech after removing element index 2");
        for(String name : nameList){
            System.out.println(name);
        }

        System.out.println("Index of Jan: " + nameList.indexOf("Jan"));
        System.out.println("Index of Sara: " + nameList.indexOf("Sara"));

        nameList.remove("Jan");
        System.out.println("Displaying elements using for ech after removing Jan from the list");
        for(String name : nameList){
            System.out.println(name);
        }

        List<String> nameListExtended = new ArrayList<>();
        nameListExtended.add("Bartosz");
        nameListExtended.add("Dariusz");
        nameListExtended.addAll(nameList); // add all elements of a list
        System.out.println("Name List Extended:");
        for(String name : nameListExtended){
            System.out.println(name);
        }

        System.out.println("Is empty? " + nameListExtended.isEmpty()); // returns true or false

        nameListExtended.set(1,"Zofia"); // change value using index
        System.out.println("After changing element index 1 to Zofia:");
        for(String name : nameListExtended){
            System.out.println(name);
        }

        List<Integer> numbersList = new ArrayList<>();
        numbersList.add(10);
        numbersList.add(20);
        numbersList.add(20);
        numbersList.add(30);
        System.out.println("Numbers List:");
        for(int number : numbersList){
            System.out.println(number);
        }

    }
}
